library ieee; use ieee.std_logic_1164.all;
entity interface is
port (
d: in std_logic_vector (6 downto 0); 
clk: in std_logic;
out_0, out_1, out_2, out_3, out_4, out_5, out_6, out_7,
out_8, out_9, out_10, out_11, out_12, out_13, out_14, out_15
: in std_logic_vector (3 downto 0);
reset: out std_logic;
in_0, in_1, in_2, in_3, in_4, in_5, in_6, in_7,
in_8, in_9, in_10, in_11, in_12, in_13, in_14, in_15
: out std_logic_vector (3 downto 0);
result: out std_logic_vector (3 downto 0)
);
end interface;

architecture functional of interface is
signal address_strobe, write, read: std_logic;
signal data_in, address_register: std_logic_vector (3 downto 0);
begin
address_strobe <= d(6);
--read <= d(5)and not(d(4));
write <= d(4) and not(d(5));
data_in <= d(3 downto 0);
reset <= d(4) and d(5);

--address register
process (clk)
begin
if clk'event and clk = '1' then
if address_strobe = '1' then address_register <= data_in; end if;
end if;
end process;

--registers
process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0000" and write = '1' then in_0 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0001" and write = '1' then in_1 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0010" and write = '1' then in_2 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0011" and write = '1' then in_3 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0100" and write = '1' then in_4 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0101" and write = '1' then in_5 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0110" and write = '1' then in_6 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "0111" and write = '1' then in_7 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1000" and write = '1' then in_8 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1001" and write = '1' then in_9 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1010" and write = '1' then in_10 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1011" and write = '1' then in_11 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1100" and write = '1' then in_12 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1101" and write = '1' then in_13 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1110" and write = '1' then in_14 <= data_in; end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '1' then
if address_register = "1111" and write = '1' then in_15 <= data_in; end if;
end if;
end process;

--output multiplexer
with data_in select
result <= 
out_0 when "0000",
out_1 when "0001",
out_2 when "0010",
out_3 when "0011",
out_4 when "0100",
out_5 when "0101",
out_6 when "0110",
out_7 when "0111",
out_8 when "1000",
out_9 when "1001",
out_10 when "1010",
out_11 when "1011",
out_12 when "1100",
out_13 when "1101",
out_14 when "1110",
out_15 when others;
end functional;

library IEEE;
use IEEE.std_logic_1164.all;

entity leddcd is
    port (
        d: in STD_LOGIC_VECTOR (3 downto 0);
        s: out STD_LOGIC_VECTOR (6 downto 0)
    );
end leddcd;

architecture leddcd_arch of leddcd is
begin
    with d select
        s <= "1110111" when "0000",
             "0010010" when "0001",
             "1011101" when "0010",
             "1011011" when "0011",
             "0111010" when "0100",
             "1101011" when "0101",
             "1101111" when "0110",
             "1010010" when "0111",
             "1111111" when "1000",
             "1111011" when "1001",
             "1111110" when "1010",
             "0101111" when "1011",
             "1100101" when "1100",
             "0011111" when "1101",
             "1101101" when "1110",
             "1101100" when others;
end leddcd_arch;



library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.constants.all;
entity main is
port (
d: in std_logic_vector (6 downto 0);
clk: in std_logic;
led: out std_logic_vector (7 downto 0)
);
end entity;

architecture circuit of main is

component interface
port (
d: in std_logic_vector (6 downto 0); 
clk: in std_logic;
out_0, out_1, out_2, out_3, out_4, out_5, out_6, out_7,
out_8, out_9, out_10, out_11, out_12, out_13, out_14, out_15
: in std_logic_vector (3 downto 0);
reset: out std_logic;
in_0, in_1, in_2, in_3, in_4, in_5, in_6, in_7,
in_8, in_9, in_10, in_11, in_12, in_13, in_14, in_15
: out std_logic_vector (3 downto 0);
result: out std_logic_vector (3 downto 0)
);
end component;

component leddcd
    port (
        d: in STD_LOGIC_VECTOR (3 downto 0);
        s: out STD_LOGIC_VECTOR (6 downto 0)
    );
end component;

signal out_0, out_1, out_2, out_3, out_4, out_5, out_6, out_7,
out_8, out_9, out_10, out_11, out_12, out_13, out_14, out_15
: STD_LOGIC_VECTOR (3 downto 0);
signal reset: std_logic;
signal in_0, in_1, in_2, in_3, in_4, in_5, in_6, in_7,
in_8, in_9, in_10, in_11, in_12, in_13, in_14, in_15
: STD_LOGIC_VECTOR (3 downto 0);
signal result: STD_LOGIC_VECTOR (3 downto 0);
signal decoder_output: std_logic_vector (6 downto 0);
signal read: std_logic;


component kcpsm
    Port (      address : out std_logic_vector(7 downto 0);
            instruction : in std_logic_vector(15 downto 0);
                port_id : out std_logic_vector(7 downto 0);
           write_strobe : out std_logic;
               out_port : out std_logic_vector(7 downto 0);
            read_strobe : out std_logic;
                in_port : in std_logic_vector(7 downto 0);
              interrupt : in std_logic;
                  reset : in std_logic;
                    clk : in std_logic);
    end component;

component signatu
    Port (      address : in std_logic_vector(7 downto 0);
            instruction : out std_logic_vector(15 downto 0);
                    clk : in std_logic);
    end component;

signal address : std_logic_vector(7 downto 0);
signal instruction : std_logic_vector(15 downto 0);
signal port_id : std_logic_vector(7 downto 0);
signal write_strobe : std_logic;
signal out_port : std_logic_vector(7 downto 0);
signal read_strobe : std_logic;
signal in_port : std_logic_vector(7 downto 0);
signal interrupt : std_logic;
--signal four_zeroes: std_logic_vector(3 downto 0);

signal character, command, Y_0, Y_1, Y_2, Y_3: std_logic_vector(7 downto 0);
signal start, done: std_logic;
signal X, Y, M, Z: std_logic_vector(31 downto 0);
subtype internal_states is natural range 0 to 3400 ;
signal state: internal_states;

component exponentiator
port (
x, y, m: in std_logic_vector(n-1 downto 0);
z: inout std_logic_vector(n-1 downto 0);
clk, reset, start: in std_logic;
done: out std_logic 
);
end component;


begin

--interface and decoder instantiation
label_1: interface port map (d, clk, out_0, out_1, out_2, out_3, out_4, out_5, out_6, out_7,
out_8, out_9, out_10, out_11, out_12, out_13, out_14, out_15, 
reset, in_0, in_1, in_2, in_3, in_4, in_5, in_6, in_7, 
in_8, in_9, in_10, in_11, in_12, in_13, in_14, in_15,
result);
label_2: leddcd port map (result, decoder_output);
read <= d(5) and not(d(4));
label_3: for i in 0 to 6 generate led(i) <= decoder_output(i) and read; end generate;

--application
picoblaze: kcpsm port map (address, instruction, port_id, write_strobe, out_port, 
read_strobe, in_port, interrupt, reset, clk);
program_memory: signatu port map (address, instruction, clk);

--four_zeroes <= "0000";

with port_id (0) select in_port <= 
character when '0',
command when others;

process (clk)
begin
if clk'event and clk = '0' then
if write_strobe = '1' and port_id(2 downto 0) = "011" then 
Y_3 <= out_port;
end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '0' then
if write_strobe = '1' and port_id(2 downto 0) = "010" then 
Y_2 <= out_port;
end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '0' then
if write_strobe = '1' and port_id(2 downto 0) = "001" then 
Y_1 <= out_port;
end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '0' then
if write_strobe = '1' and port_id(2 downto 0) = "000" then 
Y_0 <= out_port;
end if;
end if;
end process;

process (clk)
begin
if clk'event and clk = '0' then
if write_strobe = '1' and port_id(2 downto 0) = "100" then 
start <= out_port(0);
end if;
end if;
end process;

coprocessor: exponentiator port map(x, y, m, z, clk, reset, start, done);

out_7 <= Z(31 downto 28);
out_6 <= Z(27 downto 24);
out_5 <= Z(23 downto 20);
out_4 <= Z(19 downto 16);
out_3 <= Z(15 downto 12);
out_2 <= Z(11 downto 8);
out_1 <= Z(7 downto 4);
out_0 <= Z(3 downto 0);
out_15 <= done & done & done & done;
X <= "01110011011111111101001111111001";
M <= "11111111111111111111111111111111";
Y <= Y_3 & Y_2 & Y_1 & Y_0;

--test bench
process (clk, reset)
begin
if reset = '1' then state <= 0; character <= "00000000"; command <= "00000000";
elsif clk'event and clk = '1' then
case state is

when 0 to 99 => state <= state + 1;

when 100 => character <= "00001100"; command <= "00000001"; state <= state + 1;
when 101 to 199 => state <= state + 1;
when 200 => command <= "00000000"; state <= state + 1;
when 201 to 299 =>  state <= state + 1; 

when 300 => character <= "00101101"; command <= "00000001"; state <= state + 1;
when 301 to 399 => state <= state + 1;
when 400 => command <= "00000000"; state <= state + 1;
when 401 to 499 =>  state <= state + 1; 

when 500  => character <= "11011000"; command <= "00000001"; state <= state + 1;
when 501 to 599 => state <= state + 1;
when 600 => command <= "00000000"; state <= state + 1;
when 601 to 699 => state <= state + 1;

when 700 => character <= "00000001"; command <= "00000001"; state <= state + 1;
when 701 to 799 => state <= state + 1;
when 800 => command <= "00000000"; state <= state + 1;
when 801 to 899 =>  state <= state + 1; 

when 900 => character <= "01101011"; command <= "00000001"; state <= state + 1;
when 901 to 999 =>  state <= state + 1; 
when 1000 => command <= "00000000"; state <= state + 1;
when 1001 to 1099 => state <= state + 1;

when 1100 => character <= "00110111"; command <= "00000001"; state <= state + 1;
when 1101 to 1199 =>  state <= state + 1; 
when 1200 => command <= "00000000"; state <= state + 1;
when 1201 to 1299 => state <= state + 1;

when 1300 => character <= "00001010"; command <= "00000001"; state <= state + 1;
when 1301 to 1399 =>  state <= state + 1; 
when 1400 => command <= "00000000"; state <= state + 1;
when 1401 to 1499 => state <= state + 1;

when 1500 => character <= "00001001"; command <= "00000001"; state <= state + 1;
when 1501 to 1599 =>  state <= state + 1; 
when 1600 => command <= "00000000"; state <= state + 1;
when 1601 to 1699 => state <= state + 1;

when 1700 => character <= "00100010"; command <= "00000001"; state <= state + 1;
when 1701 to 1799 =>  state <= state + 1; 
when 1800 => command <= "00000000"; state <= state + 1;
when 1801 to 1899 => state <= state + 1;

when 1900 => character <= "01001000"; command <= "00000001"; state <= state + 1;
when 1901 to 1999 =>  state <= state + 1; 
when 2000 => command <= "00000000"; state <= state + 1;
when 2001 to 2099 => state <= state + 1;

when 2100 => character <= "11010111"; command <= "00000001"; state <= state + 1;
when 2101 to 2199 =>  state <= state + 1; 
when 2200 => command <= "00000000"; state <= state + 1;
when 2201 to 2299 => state <= state + 1;

when 2300 => character <= "01110010"; command <= "00000001"; state <= state + 1;
when 2301 to 2399 =>  state <= state + 1; 
when 2400 => command <= "00000000"; state <= state + 1;
when 2401 to 2499 => state <= state + 1;

when 2500 => character <= "00001101"; command <= "00000001"; state <= state + 1;
when 2501 to 2599 =>  state <= state + 1; 
when 2600 => command <= "00000000"; state <= state + 1;
when 2601 to 2699 => state <= state + 1;

when 2700 => character <= "00001101"; command <= "00000001"; state <= state + 1;
when 2701 to 2799 =>  state <= state + 1; 
when 2800 => command <= "00000000"; state <= state + 1;
when 2801 to 2899 => state <= state + 1;

when 2900 => character <= "11100101"; command <= "00000001"; state <= state + 1;
when 2901 to 2999 =>  state <= state + 1; 
when 3000 => command <= "00000000"; state <= state + 1;
when 3001 to 3099 => state <= state + 1;

when 3100 => character <= "00010010"; command <= "00000001"; state <= state + 1;
when 3101 to 3199 =>  state <= state + 1; 
when 3200 => command <= "00000000"; state <= state + 1;
when 3201 to 3299 => state <= state + 1;

when 3300 => command <= "00000010"; state <= state + 1;
when 3301 to 3399 => state <= state + 1;
when 3400 => command <= "00000000";

end case;
end if;
end process;
end circuit;

